#include <config.h>
#include <functions/LogDet.h>
#include <matrix/matrix.h>
#include <sarray/SArray.h>

using std::vector;

LogDet::LogDet ()
  : ScalarFunc ("logdet", 1)
{
}

double LogDet::eval (vector <SArray const *> const &args) const
{
  return logdet (args[0]->value(), args[0]->dim(true)[0]);
}

bool LogDet::checkParameterDim (vector <SArray const *> const &args) const
{
  Index const &dim = args[0]->dim(true);
  return (dim.size() == 2) && (dim[0] == dim[1]);
}

/* FIXME: we need a checkParameterValue function */

