#ifndef FUNC_SUBTRACT_H_
#define FUNC_SUBTRACT_H_

#include <functions/ScalarFunc.h>

/**
 * @short Difference of two scalars 
 * 
 * The Subtract function implements the infix operator "-" in the
 * BUGS language.  
 * <pre>
 * y <- x - z
 * </pre>
 */
class Subtract : public ScalarFunc 
{ 
public:
  Subtract ();
  double eval (std::vector <SArray const *> const &args) const;
  bool isDiscreteValued(std::vector<SArray const *> const &args) const;
};

#endif /* FUNC_SUBTRACT_H_ */
